'
'Phidget Hello World Program for all devices
'(c) Phidgets 2012
'

Imports Phidget22
Imports Phidget22.Events

Module Module1

    ' ========= General VB.NET Functions =============
    Sub printError(ByVal number As Integer, ByVal description As String)
        Console.WriteLine("Error on function call: {0} - {1}!", number, description)

    End Sub

    ' ========== Event Handling Functions ==========
    Private Sub manager_Attach(ByVal sender As Object, ByVal e As Phidget22.Events.ManagerAttachEventArgs) Handles manager.Attach
        Dim serialNumber As Integer
        Dim name As String

        Try
            serialNumber = e.Channel.DeviceSerialNumber
            name = e.Channel.DeviceName
            Console.WriteLine("Hello Device {0}, Serial Number: {1}!", name, serialNumber.ToString)
        Catch ex As Phidget22.PhidgetException
            printError(ex.ErrorCode, ex.Description)
        End Try
    End Sub

    Private Sub manager_Detach(ByVal sender As Object, ByVal e As Phidget22.Events.ManagerDetachEventArgs) Handles manager.Detach
        Dim serialNumber As Integer
        Dim name As String

        Try
            serialNumber = e.Channel.DeviceSerialNumber
            name = e.Channel.DeviceName
            Console.WriteLine("Goodbye Device {0}, Serial Number: {1}!", name, serialNumber.ToString)
        Catch ex As Phidget22.PhidgetException
            printError(ex.ErrorCode, ex.Description)
        End Try
    End Sub

    Dim WithEvents manager As Phidget22.Manager

    ' =========== Main Code ==========
    Sub Main()

        manager = New Phidget22.Manager()

        'No exception thrown on open
        manager.open()

        Console.WriteLine("Phidget Simple Playground (plug and unplug devices)")
        Console.WriteLine("Press Enter to end anytime")
        Console.Read()

        Console.WriteLine("Closing...")

        Try
            RemoveHandler manager.Attach, AddressOf manager_Attach
            RemoveHandler manager.Detach, AddressOf manager_Detach
            manager.close()
            manager = Nothing
        Catch ex As Phidget22.PhidgetException
            printError(ex.ErrorCode, ex.Description)
        End Try

    End Sub

End Module
